#ifdef __cplusplus
extern "C" {
#endif
#ifndef H_SCCSID
#include <sccs.h>
#endif
H_SCCSID(@(#)cur00.h	1.7	AIX)	/* Modified 10/7/89 01:03:51 */
/* @(#)cur00.h	6.1 87/06/11 02:05:05 */
/* 
 * (C) Copyright IBM Corp. 1989 
 * All Rights Reserved 
 * Licensed Materials - Property of IBM 
 */
/**PROLOGUE****************************************************************/
/*									  */
/* FUNCTION NAME =      cur       (/usr/lib/libcur.a)                     */
/* COMPONENT NAME =     cur00.h                                           */
/*									  */
/* DESCRIPTIVE NAME =	Ecurses include file				  */
/* FUNCTIONAL DESCRIPTION =	This file contains or calls for the	  */
/*	inclusion of all the defines and extern definitions needed by	  */
/*	most Ecurses routines. This include may be used to replace the	  */
/*	include of curses.h when converting from curses to Ecurses.	  */
/* INVOCATION = n/a							  */
/*									  */
/*									  */
/* RETURNS =	n/a							  */
/*									  */
/* EXTERNAL REFERENCES = n/a						  */
/*									  */
/* DATA STRUCTURES =							  */
/*									  */
/*------------------------------------------------------------------------*/
/* CHANGE HISTORY:							  */
/*   DATE   |INITS| CHANGE & REASON (BRIEF)				  */
/* _________|_____|______________________________________________________ */
/* 06/13/84 | dmb | Added module prologs and more comments in preparation */
/*	    |	  | for my transfer to FSD Houston.			  */
/* 08/03/84 | trm | add externs for keypad and nodelay			  */
/* 08/22/84 | trm | expand extern list used by keypad function		  */
/* 08/31/84 | trm | correct standout macro for new attribute encoding	  */
/* 10/16/84 | trm | created this include from former curses.h file.	  */
/* 11/01/84 | trm | add externals for Bx, By and za			  */
/* 11/11/84 | trm | added new externs for customized keyboard keys	  */
/* 01/02/85 | trm | moved definition for BX and BY to cur01.h             */
/* 02/13/85 | trm | added #ifndef to allow suppression of termcap vars    */
/* 04-10-85 | trm | added externals for savetty/resetty                   */
/* 10-31-86 | jcd | remove extern for ttytype                             */
/* 02/09/87 | jcd | added externs for F11 and F12                         */
/* 05/12/88 | dxe | changed HZ to HZ1 to avoid header conflicts           */
/*	    |	  |							  */
/*********************************************************************END**/

    /* TS:  for some reason, the preprocessor #defines TS (ugh)*/
#undef TS
#ifndef WINDOW

#include        "cur01.h"

	/* The semi-colon at the end of this macro is an error which  */
	/* cannot be corrected because of compatibility restrictions. */
#define _puts(s)        tputs(s, 0, eciopc);

#if (IS1|IS2|V7)
typedef struct	sgttyb	SGTTY;
#else
typedef struct	termio	SGTTY;
#endif


/* the following #ifndef will allow an application to suppress the      */
/* termcap variable names from this expansion to avoid conflicts and    */
/* reduce symbol table requirements                                     */

#ifndef NO_TCAP
/*
 * Capabilities from termcap
 */
extern	
bool	AM, BS, BW, DA, DB, EO, ES, HS,HZ1, IN, KM, MI, MS, NC, OS, UL, XN;

extern	/* numeric terminal capabilites from /etc/termcap */
int	CO, IT, LI, LM, SG, PB, VT, WS;

extern	/* string terminal capabilities from /etc/termcap */
CHAR	*AL, *AS, *AE, *BC, *BL, *BT, *CD, *CE, *CH, *CL, *CM, *CR, *CS,
	*CV, *DC, *DL, *DM, *DO, *xDO, *DS, *EC, *ED, *EI, *FS, *HO, *IC,
	*IM, *IP, *K0, *K1, *K2, *K3, *K4, *K5, *K6, *K7, *K8, *K9, *K10,
	*KS1, *KS2, *KS3, *KS4, *KS5, *KS6, *KS7, *KS8, *KS9, *KS10,
	*KDO, *KQUIT, *KCMD, *KPCMD, *KNPN, *KPPN, *KCPN, *KHLP, *KSEL,
	*KSCL, *KSCR, *KTAB, *KBTAB, *KNL, *KEND,
	*KA, *Ka, *KB, *KC, *KA1, *KA3, *KB2, *KC1, *KC3, *KD,
	*Kd, *KE, *Ke, *KF, *KH, *Kh, *KI, *KL, *Kl, *Km, *KN, *KO, *KP,
	*KR, *Kr, *KS, *Ks, *KT, *Kt, *Ku, *L0, *L1, *L2, *L3, *L4, *L5,
	*L6, *L7, *L8, *L9, *L10, *LE, *xLE, *LL,*MA, *MB, *MD, *ME, *MH,
	*MK, *MM, *MO, *MP, *MR, *ND, *NL, *xPC, *xRI, *SE, *SF, *SO, *SR,
	*TA, *TE, *TI, *TS, *UC, *UE, *UP, *xUP, *US, *VB, *VE, *VI, *VS,
	*Bx, *By, *CF[8], *CB[8], *FO[8], *ZA,
	*K11, *K12, *K13, *K14, *K15, *K16, *K17, *K18, *K19, *K20,
	*K21, *K22, *K23, *K24, *K25, *K26, *K27, *K28, *K29, *K30,
	*K31, *K32, *K33, *K34, *K35, *K36, *K37, *K38, *K39, *K40,
	*K41, *K42, *K43, *K44, *K45, *K46, *K47, *K48, *K49, *K50,
	*K51, *K52, *K53, *K54, *K55, *K56, *K57, *K58, *K59, *K60,
	*K61, *K62, *K63;

extern	/* the following pairs of strings provide a mapping from	  */
CHAR	/* keyboard string to sequence of return codes - see keypad	  */
	*KEXT_S1, *KEXT_S2, *KEXT_S3, *KEXT_S4, *KEXT_S5,
	*KEXT_R1, *KEXT_R2, *KEXT_R3, *KEXT_R4, *KEXT_R5,
	*KEXT_S6, *KEXT_S7, *KEXT_S8, *KEXT_S9,
	*KEXT_R6, *KEXT_R7, *KEXT_R8, *KEXT_R9 ;

extern	int	Bxa, Bya ;	/* attr mask for attrs named in Bx & By   */

#endif


/*
 * From the tty modes...
 */
extern	bool	CA, GT, NONL, UPPERCASE, normtty, _pfast;

extern bool	My_term, _echoit, _rawmode, _endwin;
extern bool	_keypad, _nodelay ;

extern CHAR     *Def_term;

extern int	_tty_ch, CE_cost, EC_cost;

extern SGTTY    _tty, _res_flg, _ctty ;
extern int      _fcntl, _cfcntl ;

#endif

#ifdef __cplusplus
}
#endif
