#ifdef __cplusplus
extern "C" {
#endif
/* @(#)cur99.h	6.1-87/06/11-05:50:27 */
/**PROLOGUE****************************************************************/
/*									  */
/* FUNCTION NAME =      cur     (/usr/lib/libcur.a)                       */
/* COMPONENT NAME =     cur99.h                                           */
/*									  */
/* DESCRIPTIVE NAME =	curses external variables			  */
/* FUNCTIONAL DESCRIPTION =	This file contains the global variable	  */
/*	declarations used by the other curses routines. 		  */
/*									  */
/* INVOCATION = n/a							  */
/*									  */
/*									  */
/* RETURNS =	n/a							  */
/*									  */
/* EXTERNAL REFERENCES = none						  */
/*									  */
/* DATA STRUCTURES =	n/a						  */
/*									  */
/*------------------------------------------------------------------------*/
/* CHANGE HISTORY:							  */
/*   DATE   |INITS| CHANGE & REASON (BRIEF)                               */
/* _________|_____|______________________________________________________ */
/* 06/13/84 | dmb | Added module prologs and more comments in preparation */
/*	    |	  | for my transfer to FSD Houston.			  */
/* 08/03/84 | trm | added externs for keypad and nodelay		  */
/* 10/16/84 | trm | Changed names and includes for Ecurses structure	  */
/* 10/31/86 | jcd | Removed extern declaration for ttytype.               */
/* 11/20/86 | jcd | add HIDE_MASK define.                                 */
/* 02/20/87 | jcd | ATTR: char->ATTR                                      */
/*          |     |                                                       */
/*********************************************************************END**/

#ifndef H_SCCSID
#include <sccs.h>
#endif
H_SCCSID(@(#)cur99.h	1.6	AIX)	/* Modified 9/17/89 02:12:44 */
/*	curses.ext_SCCS - @(#)cur99.h	6.1-87/06/11-05:50:27					  */
/* 
 * (C) Copyright IBM Corp. 1989 
 * All Rights Reserved 
 * Licensed Materials - Property of IBM 
 */

/* LINTLIBRARY */

# ifndef	CHAR
#define	CHAR	unsigned char	/* Defined to support diff default in CC */
# endif		/* CHAR */

#include        "cur00.h"
#include        "cur04.h"

	/* the all important structure for the attribute information */
struct	attr_mask {		/* structure to contain our masks */
	short	start_bit;	/* bit at which this mask starts */
	short	type_attr;	/* 1-switch, 2-f_color, 3-b_color, 4-font */
	short	num_val;	/* number of elements in this mask */
	ATTR    act_attr;       /* actual pattern for ANDing this mask */
	CHAR    *set[8];        /* strings to set each element */
	CHAR	*reset; 	/* string to unset this set or individual */
	};

extern  ATTR    sw_mask ;       /* mask for all switch type attributes    */

extern	bool	_echoit, _rawmode, My_term, _endwin;
extern	bool	_keypad, _nodelay ;

extern  CHAR    *_unctrl[];

extern	int	_tty_ch, LINES, COLS;

extern	SGTTY	_tty, _res_flg;

CHAR            eciopc();

extern	int	CE_cost, EC_cost;	/* cost analysis variables */

#define HIDE_MASK       0x01
#ifdef __cplusplus
}
#endif
