#ifdef __cplusplus
extern "C" {
#endif
#ifndef H_MALLOC
#define H_MALLOC
#ifndef H_SCCSID
#include <sccs.h>
#endif /* ~H_SCCSID */
H_SCCSID(@(#)malloc.h	1.10	AIX)	/* Modified: 2/26/92 10:34:19 */
/*	@(#)malloc.h	1.2	*/
/* 
 * (C) Copyright IBM Corp. 1989 
 * All Rights Reserved 
 * Licensed Materials - Property of IBM 
 */

/*
	Constants defining mallopt operations
*/
#define M_MXFAST	1	/* set size of blocks to be fast */
#define M_NLBLKS	2	/* set number of block in a holding block */
#define M_GRAIN		3	/* set number of sizes mapped to one, for
				   small blocks */
#define M_KEEP		4	/* retain contents of block after a free until
				   another allocation */
/*
	structure filled by 
*/
struct mallinfo  {
	int arena;	/* total space in arena */
	int ordblks;	/* number of ordinary blocks */
	int smblks;	/* number of small blocks */
	int hblks;	/* number of holding blocks */
	int hblkhd;	/* space in holding block headers */
	int usmblks;	/* space in small blocks in use */
	int fsmblks;	/* space in free small blocks */
	int uordblks;	/* space in ordinary blocks in use */
	int fordblks;	/* space in free ordinary blocks */
	int keepcost;	/* cost of enabling keep option */
};	

/* (MRL) Corrected the prototypes for all functions */
#include <stddef.h>
extern void	*malloc(size_t);
extern void	free(void*);
extern void 	*calloc(size_t, size_t);
extern void	*realloc(void*, size_t);
extern int	mallopt(int,int);
extern mallinfo mallinfo(int);
/* (MRL) End of Mods */
#endif
#ifdef __cplusplus
}
#endif
