#ifdef __cplusplus
extern "C" {
#endif
#ifndef H_SCCSID
#include <sccs.h>
#endif /* ! H_SCCSID */
H_SCCSID(@(#)trcdefs.h	1.8	AIX)	/* Modified 9/17/89 01:51:48 */
/* @(#)55X8899 (c) Copyright IBM Corp. 1985, 1989
   @(#)Licensed Material - Program Property of IBM */

/* include file trcdefs.h                                       *
 *   contains symbolic constant and data type definitions for   *
 *   applications using the system trace function.     */

#define MAXDATA         20    /* Max. number of chars in record data field.*/

				  /* Distributed Services components    */
#define DS_RESERVED     bit9            /* reserved                     */
#define DS_RIPC         bit8            /* remote IPC                   */
#define DS_MISC         bit7            /* rpc miscellaneous            */
#define DS_LK           bit6            /* rpc DS locking               */
#define DS_OC           bit5            /* rpc DS open/close            */
#define DS_RW           bit4            /* rpc DS read/write            */
#define DS_SS           bit3            /* rpc server sending           */
#define DS_CR           bit2            /* rpc client receiving         */
#define DS_CS           bit1            /* rpc client sending           */
	/* VRM Components */
#define SVC             bit4            /* SVC Handler                  */
#define EM3270          bit5            /* 3270 Emulator Device Dr.     */
#define VTM             bit8            /* Virtual Terminal Mgr.        */
#define KBINT           bit9            /* Virt. Term. Keyboard Intrpt. */
#define LOCINT          bit10           /* Virt. Term. Locator Intrpt.  */
#define ASYNCINT        bit11           /* Async Device Driver Intrpt.  */
#define ASYNC           bit13           /* Async Device Driver          */
#define COPROC          bit14           /* Co-Processor                 */
#define SSLA            bit17           /* SSLA D.D.                    */
#define DEVDRV          bit17           /* Generic Device Driver Trace  */
#define DFTDD           bit18           /* DFT D.D.                     */
/* The following are bit masks to be used by running programs to test   *
 * whether their respective event types are currently set to trace.
 * Assumes that the bits are numbered 0-31 from highest- to lowest-order. */

#define bit31   0x00000001
#define bit30   0x00000002
#define bit29   0x00000004
#define bit28   0x00000008
#define bit27   0x00000010
#define bit26   0x00000020
#define bit25   0x00000040
#define bit24   0x00000080
#define bit23   0x00000100
#define bit22   0x00000200
#define bit21   0x00000400
#define bit20   0x00000800
#define bit19   0x00001000
#define bit18   0x00002000
#define bit17   0x00004000
#define bit16   0x00008000
#define bit15   0x00010000
#define bit14   0x00020000
#define bit13   0x00040000
#define bit12   0x00080000
#define bit11   0x00100000
#define bit10   0x00200000
#define bit9    0x00400000
#define bit8    0x00800000
#define bit7    0x01000000
#define bit6    0x02000000
#define bit5    0x04000000
#define bit4    0x08000000
#define bit3    0x10000000
#define bit2    0x20000000
#define bit1    0x40000000
#define bit0    0x80000000

/* Programs using these masks to check their trace status should call   *
 * the trace_on() function with the mask as its argument to get the   *
 * status of their trace channel.  */

	/* Applications and AIX extensions */
/*      COPROC          bit11              Coprocessor                  */
#define CONFIG          bit22           /* Config                       */
#define PCSERV          bit30           /* PC Server                    */
	/* AIX system calls */
#define SHMEMORY        bit30           /* Shared Memory                */
#define MESSAGES        bit29           /* Messages                     */
#define SEMAPHOR        bit28           /* Semaphores                   */
#define SIGNALS         bit27           /* Signals                      */
#define TIME            bit26           /* Time                         */
#define FILESYS         bit25           /* File System                  */
#define IOSYS           bit24           /* File Handling                */
#define DIRHANDL        bit23           /* Directory Handling           */
#define PROCESS         bit22           /* Process                      */
#define SSLAU           bit15           /* SSLA AIX d. d.               */
#define BASELAN         bit14           /* Base LAN Device Driver       */
	/* VRM Components */
#define SVC             bit4            /* SVC Handler                  */
#define EM3270          bit5            /* 3270 Emulator Device Dr.     */
#define VTM             bit8            /* Virtual Terminal Mgr.        */
#define KBINT           bit9            /* Virt. Term. Keyboard Intrpt. */
#define LOCINT          bit10           /* Virt. Term. Locator Intrpt.  */
#define ASYNCINT        bit11           /* Async Device Driver Intrpt.  */
#define ASYNC           bit13           /* Async Device Driver          */
#define COPROC          bit14           /* Co-Processor                 */
#define SSLA            bit17           /* SSLA D.D.                    */

/* bits 24-30 reserved for generic commo tracing */

	/* User-defined trace points on any system level        */
#define USER            bit31           /* Any user-defined trace points*/
#ifdef __cplusplus
}
#endif
