#ifdef __cplusplus
extern "C" {
#endif
#ifndef H_SCCSID
#include <sccs.h>
#endif /* ! H_SCCSID */
H_SCCSID(@(#)vrccharstr.h	1.2	AIX PS/2)	/* Modified: 9/17/89 02:01:23 */

/* @(#)vrccharstr.h	7.2 - 87/11/18 - 23:06:24 */

/*  (c) Copyright IBM Corp. 1985, 1989  */
/*  Licensed Material - Program Property of IBM*/
/*
*               vrccharstr.h -- keyword definitions (character strings)
*
*/

				/* define device - common keywords    */

#define IODN    "iodn"          /* iodn                               */
#define IOCN    "iocn"          /* iocn                               */
#define SHARED  "shared"        /* shared (between virtual machines ) */
#define TYPE    "type"          /* type identifier                    */
#define NAME    "name"          /* device name                        */


				/* hardware characteristics keywords  */


#define IOBUS      "nr"                  /* no ROM             */
#define SWTCH      "switchable"            /* switchable device          */
#define DEVWDTH    "ddbw"                  /* adapter device bus width   */
#define NINTS      "noi"                   /* number of interrupts       */
#define SLOT       "sn"                    /* slot number for adapter    */
#define EBOX       "eus"                   /* expansion unit slot        */
#define ADPTYP     "at"                    /* adapter identifier         */
#define PORTNUM    "pn"                    /* port number on adapter     */
#define IOPADDBASE "biopa"                 /* i/o port address           */
#define IOPADDRANG "iopar"                 /* range of i/o addresses     */
#define BUSMEMSTRT "brsa"            /* bus memory start address   */
#define BUSMEMEND  "brea"             /* bus memory  end address    */
#define RASLEN    "rl"                /* ras length */

#define DMASUP     "dmas"                  /* device supports dma        */
#define FSTPARTY   "fp"                    /* first party dma support    */
#define USEIOCC    "ioccb"                 /* use iocc                   */
#define SHRDDMA    "sdmac"                 /* shared dma channel support */
#define DMAONLY    "dmao"                  /* dma only device (no pi/o)  */
#define CPCHANL    "dnec"               /* do not enable channel       */
#define SCATGATH   "sg"                    /* scatter/gather dma support */
#define NWINDOW    "now"                   /* number of dma windows      */
#define CHANNEL    "cn"                    /* adapter dma channel used   */
#define RSA        "rsa"                   /* romp start address         */
#define REA        "rea"                   /* romp end address           */



			/* interrupt support (hardware characteristics) */

#define ENINTS      "ei"                /* enable interrupts (auto )  */
#define SHARINTS    "si"                /* sharable interrupt level   */
#define POLL        "poll"              /* poll with every interrupt  */
#define CLASS       "ic"                /* vmi interrupt class        */
					/*    (within level)          */
#define INTLEVEL    "il"                /* interrupt level (hardware) */
#define INTPORTADD  "intportadd"        /* interrupt port address     */
					/*    (status )               */
#define INTSTAAND   "intstaand"         /* interrupt status and mask  */
#define INTSTAOR    "intstaor"          /* interrupt status or masl   */

				/* device characteristics keywords    */

#define AE     "ae"                     /* automatic enable (ddi file)   */
#define TT      "tt"                    /* terminal type (ddi file)      */
#define ENABLED     "enabled"           /* enable the tty at ipl         */
#define TERM        "term"              /* terminal type                 */
#define RS          "rts"               /* receive/transmit speed        */
#define DVAM        "dvam"              /* device attachment method      */
#define PT          "pt"                /* parity type (ddi file)        */
#define NOSB        "nosb"              /* number of stop bits (ddi file */
#define BPC         "bpc"               /* bits per character (ddi file) */
#define PARITY      "parity"            /* parity type                   */
#define LOGMODES    "logmodes"          /* logmodes keyword              */
#define SPEED       "speed"


				/* etc master keywords               */

#define MAJOR     "major"               /* UDD major number          */
#define MAXMINOR  "maxminor"            /* max number of minor numbers */
#define PREFIX    "prefix"              /* UDD character prefix      */
#define ROUTINES  "routines"            /* UDD routines              */
#define VDRIVER   "vdriver"             /* vrm device driver         */
#define DVDRIVER  "dvdriver"            /* dummy vrm device driver   */
#define TTY       "tty"                 /* tty                       */
#define MPX       "mpx"                 /* multiplex device driver   */
#define MANDATORY "mandatory"           /* mandatory device          */
#define CONFIG    "config"              /* config helper routine     */
#define CODE      "code"                /* code name                 */
#define COPY      "copy"                /* copy identifier           */
#define CTYPE     "ctype"               /* code type identifier      */

				 /* etc system       keywords         */

#define MODES     "modes"                /* file access modes         */
#define OWNER "owner"
#define DRIVER    "driver"               /* driver name               */
#define MINOR     "minor"                /* minor number identifier   */
#define VDMGR     "vdmgr"                /* device manager device names */
#define KAF_FILE  "kaf_file"             /* name of kaf file          */
#define KAF_USE   "kaf_use"              /* name of kaf file stanza   */
#define NOSPECIAL "nospecial"            /* nospecial file ( no UDD0  */
#define DTYPE     "dtype"                /* device type identified    */
#define DFILE     "file"                 /* ddi file name             */
#define USE       "use"                  /* ddi stanza name           */
#define VINT      "vint"                 /* virtual interrupt level   */
#define NODELETE  "nodelete"             /* nodelete parameter        */
#define ADMGR     "admgr"                /* device manager pointer    */
#define SPECPROC  "specproc"             /* special processing        */
#define ASYNC     "async"                /* async UDD identifier      */
#define PROTOCOL  "protocol"             /* protocol procedure indicator */
#define NOCOPY    "nocopy"               /* nocopy keyword            */
#define NOIPL     "noipl"                /* noipl keyword            */

				/* /etc/qconfig keywords               */

#define DEVICE     "device"              /* device keyword             */
#define BACKEND    "backend"             /* backend keyword           */

				/* /etc/ports keyword                  */

#define ODD         "odd"                /* parity values */
#define EVEN        "even"
#define NONE        "none"
#define TWOSBITS    "2"                  /* stop bit value */
#define NOSB1       "-cstopb"
#define NOSB2       "+cstopb"
#define CS          "cs"



/* constant definitions */
			    /* options for calls to vrmconfig */
#define AOPT "a"            /*  add */
#define AUOPT "ua"          /*  update the AIX specific information */
#define DUOPT "ud"          /*  update the AIX specific information */
#define AVOPT "va"          /*  update the VRM specific information */
#define DOPT "d"            /*  delete */
#define SPACE 040
#define SPFILE "/etc/specials"      /* file name for the special */
				    /*     file list             */
#define VRMCONFIG "/etc/vrmconfig"  /* path to vrmconfig */
#define MAXARGS 50          /* maximum number of arguments in the    */
			    /* argument list passed to fork_exec routine*/
#define MAJORMIN  21        /* minimum value for a generated major number*/
#define MAJORMAX  31       /* maximum value for a generated major number*/
#define IOCNMIN   1024      /* minimum value for a generated IOCN */
#define IOCNMAX   16383     /* maximum value for a generated IOCN */
#define IODNMIN   5072      /* minimum value for a generated IODN */
#define IODNMAX   16383     /* maximum value for a generated IODN */


#define MAPPREFIX "m"       /* prefix used with the mapped keyword values */
#ifdef __cplusplus
}
#endif
